#2011, Eulalie Sauthier, Master Thesis

temps_retour <- function(input_data, colonne) {

#permet de produire des graphes de temps de retour et les GEV paramètres des stations connues
	
library(evd) #librarie
out<-vector(length=(length(input_data[ ,colonne])/12)) #déclation
j<-1;k<-1;i<-1

out[1]<-max(input_data[1:12,colonne]) #on garde les valeurs maximum
o<-13;r<-24
max_<-(length(input_data[ ,1])/12)

for(i in 2:max_){
out[i]<-max(input_data[o:r,colonne]) #garde les valeurs maximales
o<-o+12;r<-r+12;
}

mo<-fgev(out) #calcule les GEV paramètres 
temp<-mo$param #mu sigma xi
val<-180
Weib<-vector(length=val)
for (T in 1:val) #utilisation de la formule de la loi de Weibul
if(mo$param[3] !=0){
Weib[T]= mo$param[1] - (mo$param[2] /mo$param[3]) * (1-(-log(1-(1/T)))^-mo$param[3])
}else{
Weib[T]= mo$param[1] - mo$param[2] * (-log(1/T))
}

pf<-paste("../Image/Temps_retour",colnames(input_data)[colonne],".pdf")
pdf(pf)
plot(1:180,Weib, log="x",xlab="Temps de retour [année]",ylab="Precipitations en [mm]",main=paste("Temps de retour", colnames(input_data)[colonne]))
dev.off()
#
pf<-paste("../Image/Temps_retour_auto",colnames(input_data)[colonne],".pdf")
pdf(pf)
M1 <- fgev(out)
plot.uvevd(M1,which=4,main=paste("Temps_retour_auto",colnames(input_data)[colonne]))
dev.off()

return(M1$estimate)

}
